#include <avr/io.h>
#include "config.h"
#include <stdlib.h>
#include "wait1000ms.h"
#include "lcd-routines.h"


// ANZ_MES = 44 fr hchste Genauigkeit, Summe von 44 einzelnen Messungen
// ANZ_MES = 22 fr mittlere Genauigkeit, 22 einzelne Messungen, Ergebnis wird zustzlich mit 2 multipliziert
// ANZ_MES = 11 fr hchste Geschwindigkeit, 11 einzelne Messungen, Ergebnis wird mit 4 multipliziert
// Durch die anschliessende Division durch 9 wird jeweils eine mV Auflsung erreicht.

#define ANZ_MES 44

unsigned int ReadADC(uint8_t mux)
 { //ADC-Wert des angegebenen Kanals auslesen und als unsigned int zurckgeben
  ADMUX = mux | (1<<REFS0);
  unsigned int adcx = 0;

  for(uint8_t j=0;j<(ANZ_MES+1);j++)
    {	//ANZ_MESS Messungen; fr bessere Genauigkeit
     ADCSRA |= (1<<ADSC);		//starte Conversion
     while (ADCSRA&(1<<ADSC));		//warte
     if(j!=0)adcx += ADCW;		// 1. Messung verwerfen
    }
#if ANZ_MES == 22
  adcx *= 2;
#endif
  
#if ANZ_MES == 11
  adcx *= 4;
#endif
  return adcx/9;
 }

unsigned int W20msReadADC(uint8_t mux)
  {
   wait20ms();
   return (ReadADC(mux));
  }
  

unsigned int W5msReadADC(uint8_t mux)
  {
   wait20ms();
   return (ReadADC(mux));
  }

